// инициализация
// QR
// Restore Factory Settings (сброс до заводских настроек)
// UART Output     (обмен по UART)
// Continuous Mode (сканирование непрерывно, без нажатия кнопки)
// Non-Scanning Interval (2000 мс)
// Lighting - No light (без светодиода)

#include <SPI.h>
#include <WiFi101.h>

//#include "arduino_secrets.h" 

#include <Arduino.h>                              
#include <wiring_private.h>

char ssid[] = "Kassa1";        // your network SSID (name)
char pass[] = "12345678";    // your network password (use for WPA, or use as key for WEP)
int status = WL_IDLE_STATUS;     // the WiFi radio's status

// Serial2 pin and pad definitions (in Arduino files Variant.h & Variant.cpp)
#define PIN_SERIAL2_RX       (1ul)                // Pin description number for PIO_SERCOM on D1
#define PIN_SERIAL2_TX       (0ul)                // Pin description number for PIO_SERCOM on D0
#define PAD_SERIAL2_TX       (UART_TX_PAD_0)      // SERCOM pad 0 TX
#define PAD_SERIAL2_RX       (SERCOM_RX_PAD_1)    // SERCOM pad 1 RX

// Serial3 pin and pad definitions (in Arduino files Variant.h & Variant.cpp)
//#define PIN_SERIAL3_RX       (5ul)                // Pin description number for PIO_SERCOM on D5
//#define PIN_SERIAL3_TX       (4ul)                // Pin description number for PIO_SERCOM on D4
//#define PAD_SERIAL3_TX       (UART_TX_PAD_2)      // SERCOM pad 2 TX
//#define PAD_SERIAL3_RX       (SERCOM_RX_PAD_3)    // SERCOM pad 3 RX

Uart Serial2(&sercom3, PIN_SERIAL2_RX, PIN_SERIAL2_TX, PAD_SERIAL2_RX, PAD_SERIAL2_TX);
//Uart Serial3(&sercom4, PIN_SERIAL3_RX, PIN_SERIAL3_TX, PAD_SERIAL3_RX, PAD_SERIAL3_TX);
WiFiClient client;
// данные, пришедшие из последовательного порта
String inputString1 = "";        
String inputString2 = "";        
// строка пришла
boolean stringComplete1 = false;  
int countstr1=0;
boolean stringComplete2 = false;  
int countstr2=0;
// для поиска окончания
unsigned long millisendstr1=0;
unsigned long millisendstr2=0;

String message;
String barcode="";
// name address 
char server[] = "www.freeparkovka.ru";    
char response[60];
int counter=0;

void SERCOM3_Handler()    // Interrupt handler for SERCOM3
{
Serial2.IrqHandler();
}
//void SERCOM4_Handler()    // Interrupt handler for SERCOM4
//{
//  Serial3.IrqHandler();
//}

void setup() {
  // 
  Serial.begin(9600);
  while (!Serial) {
    ; // wait for serial port to connect. Needed for native USB port only
  }
  Serial.println("Serials start");
  pinPeripheral(0, PIO_SERCOM);   // Assign pins 0 & 1 SERCOM functionality
  pinPeripheral(1, PIO_SERCOM);
  Serial2.begin(9600);               // Begin Serial2
  //pinPeripheral(4, PIO_SERCOM_ALT);   // Assign pins 4 & 5 SERCOM functionality
  //pinPeripheral(5, PIO_SERCOM_ALT);
  //Serial3.begin(9600);               // Begin Serial3
  Serial1.begin(9600);
  
  // резервирование 50 bytes для inputString:
  inputString1.reserve(50);
  inputString2.reserve(50);  
  // Nextion
  Serial2.print("t0.txt=\"wait ...\"");
  Serial2.write(0xff);
  Serial2.write(0xff);
  Serial2.write(0xff);    
  delay(10);  
  Serial2.print("n0.val=");
  Serial2.print(counter);    
  Serial2.print("");
  Serial2.write(0xff);
  Serial2.write(0xff);
  Serial2.write(0xff);    
  delay(10);  

  Serial.println("Serials ok");
  // check for the presence of the shield:
  if (WiFi.status() == WL_NO_SHIELD) {
    Serial.println("WiFi shield not present");
    // don't continue:
    while (true);
  }

  // attempt to connect to WiFi network:
  while ( status != WL_CONNECTED) {
    Serial.print("Attempting to connect to WPA SSID: ");
    Serial.println(ssid);
    // Connect to WPA/WPA2 network:
    status = WiFi.begin(ssid, pass);

    // wait 10 seconds for connection:
    delay(5000);
  }

  // once you are connected :
  Serial.print("You're connected to the network");
  printCurrentNet();
  printWiFiData();
}

void loop() {
  // 
  serialScanerEvent1(); 
  if (stringComplete1) {
    Serial.println(inputString1);
    Serial2.print("t0.txt=\"");
    Serial2.print(inputString1);
    Serial2.print("\"");
    Serial2.write(0xff);
    Serial2.write(0xff);
    Serial2.write(0xff);  
    barcode=inputString1;      
    // очистить строку
    inputString1 = "";
    stringComplete1 = false;
    countstr1=0;
   }
  serialNextionEvent2(); 
  if (stringComplete2) {
    //Serial.println(inputString2); 
    parse_message(inputString2);
    // очистить строку
    inputString2 = "";
    stringComplete2 = false;
    countstr2=0;
   }  
  
}

void serialScanerEvent1() {
  //
  if (Serial1.available()>0) {
    // get the new byte:
    char inChar = (char)Serial1.read();
    // add it to the inputString:
    inputString1 += inChar;
    countstr1++;
    millisendstr1=millis();
  }
  else {
    if(millis()-millisendstr1>1000 && countstr1>0) {
       stringComplete1=true;
    }
  }
}

void serialNextionEvent2() {
  //
  if (Serial2.available()>0) {
    // get the new byte:
    char inChar = (char)Serial2.read();
    // add it to the inputString:
    inputString2 += String(inChar,HEX);
    countstr2++;
    inputString2 += " ";
    countstr2++;
    millisendstr2=millis();
  }
  else {
    if(millis()-millisendstr2>200 && countstr2>0) {
       stringComplete2=true;
    }
  }
}
